/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import { Contract, ContractTransaction, EventFilter, Signer } from "ethers";
import { Listener, Provider } from "ethers/providers";
import { Arrayish, BigNumber, BigNumberish, Interface } from "ethers/utils";
import {
  TransactionOverrides,
  TypedEventDescription,
  TypedFunctionDescription
} from ".";

interface ERC1820RegistryInterface extends Interface {
  functions: {
    setInterfaceImplementer: TypedFunctionDescription<{
      encode([_addr, _interfaceHash, _implementer]: [
        string,
        Arrayish,
        string
      ]): string;
    }>;

    getManager: TypedFunctionDescription<{ encode([_addr]: [string]): string }>;

    setManager: TypedFunctionDescription<{
      encode([_addr, _newManager]: [string, string]): string;
    }>;

    getInterfaceImplementer: TypedFunctionDescription<{
      encode([_addr, _interfaceHash]: [string, Arrayish]): string;
    }>;
  };

  events: {};
}

export class ERC1820Registry extends Contract {
  connect(signerOrProvider: Signer | Provider | string): ERC1820Registry;
  attach(addressOrName: string): ERC1820Registry;
  deployed(): Promise<ERC1820Registry>;

  on(event: EventFilter | string, listener: Listener): ERC1820Registry;
  once(event: EventFilter | string, listener: Listener): ERC1820Registry;
  addListener(
    eventName: EventFilter | string,
    listener: Listener
  ): ERC1820Registry;
  removeAllListeners(eventName: EventFilter | string): ERC1820Registry;
  removeListener(eventName: any, listener: Listener): ERC1820Registry;

  interface: ERC1820RegistryInterface;

  functions: {
    setInterfaceImplementer(
      _addr: string,
      _interfaceHash: Arrayish,
      _implementer: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    getManager(_addr: string): Promise<string>;

    setManager(
      _addr: string,
      _newManager: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    getInterfaceImplementer(
      _addr: string,
      _interfaceHash: Arrayish
    ): Promise<string>;
  };

  setInterfaceImplementer(
    _addr: string,
    _interfaceHash: Arrayish,
    _implementer: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  getManager(_addr: string): Promise<string>;

  setManager(
    _addr: string,
    _newManager: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  getInterfaceImplementer(
    _addr: string,
    _interfaceHash: Arrayish
  ): Promise<string>;

  filters: {};

  estimate: {
    setInterfaceImplementer(
      _addr: string,
      _interfaceHash: Arrayish,
      _implementer: string
    ): Promise<BigNumber>;

    getManager(_addr: string): Promise<BigNumber>;

    setManager(_addr: string, _newManager: string): Promise<BigNumber>;

    getInterfaceImplementer(
      _addr: string,
      _interfaceHash: Arrayish
    ): Promise<BigNumber>;
  };
}
